from graphics_and_games_klassen import Rechteck, Dreieck, Kreis

class Dame:
    """
    Stellt eine Dame auf der Grafikoberfläche dar.
    """
    def __init__(self):
        """
        Erzeugt die Einzelteile der Dame.
        """
        self.x = 50
        self.y = 50
        self.basis = Rechteck()
        self.basis.FarbeSetzen("orange")
        self.basis.GrößeSetzen(40, 10)
        self.zacke1 = Dreieck()
        self.zacke1.FarbeSetzen("orange")
        self.zacke1.GrößeSetzen(10, 20)
        self.zacke2 = Dreieck()
        self.zacke2.FarbeSetzen("orange")
        self.zacke2.GrößeSetzen(10, 20)
        self.zacke3 = Dreieck()
        self.zacke3.FarbeSetzen("orange")
        self.zacke3.GrößeSetzen(10, 20)
        self.zacke4 = Dreieck()
        self.zacke4.FarbeSetzen("orange")
        self.zacke4.GrößeSetzen(10, 20)
        self.kreis1 = Kreis()
        self.kreis1.FarbeSetzen("orange")
        self.kreis1.RadiusSetzen(2)
        self.kreis2 = Kreis()
        self.kreis2.FarbeSetzen("orange")
        self.kreis2.RadiusSetzen(2)
        self.kreis3 = Kreis()
        self.kreis3.FarbeSetzen("orange")
        self.kreis3.RadiusSetzen(2)
        self.kreis4 = Kreis()
        self.kreis4.FarbeSetzen("orange")
        self.kreis4.RadiusSetzen(2)
        self.PositionSetzen(0, 0)

    def Anordnen(self):
        """
        Ordnet die Teile gemäß der Position an.
        """
        self.basis.PositionSetzen(self.x + 5, self.y + 35)
        self.zacke1.PositionSetzen(self.x + 10, self.y + 15)
        self.zacke2.PositionSetzen(self.x + 20, self.y + 15)
        self.zacke3.PositionSetzen(self.x + 30, self.y + 15)
        self.zacke4.PositionSetzen(self.x + 40, self.y + 15)
        self.kreis1.PositionSetzen(self.x + 10, self.y + 13)
        self.kreis2.PositionSetzen(self.x + 20, self.y + 13)
        self.kreis3.PositionSetzen(self.x + 30, self.y + 13)
        self.kreis4.PositionSetzen(self.x + 40, self.y + 13)

    def PositionSetzen(self, zeile, spalte):
        """
        Setzt die Position auf dem Schachbrett.
        Das Brett hat links oben die Koordinaten (50|50).
        """
        self.x = 50 + spalte * 50
        self.y = 400 - zeile * 50
        self.Anordnen()

    def SichtbarkeitSetzen(self, sichtbar):
        """
        Steuert die Sichtbarkeit der Dame.
        """
        self.basis.SichtbarkeitSetzen(sichtbar)
        self.zacke1.SichtbarkeitSetzen(sichtbar)
        self.zacke2.SichtbarkeitSetzen(sichtbar)
        self.zacke3.SichtbarkeitSetzen(sichtbar)
        self.zacke4.SichtbarkeitSetzen(sichtbar)
        self.kreis1.SichtbarkeitSetzen(sichtbar)
        self.kreis2.SichtbarkeitSetzen(sichtbar)
        self.kreis3.SichtbarkeitSetzen(sichtbar)
        self.kreis4.SichtbarkeitSetzen(sichtbar)




class Schachbrett:
    """
    Verwaltet das Schachbrett und die Damen.
    """
    def __init__(self):
        """
        Legt das Schachbrett und die Damen an.
        """
        self.brett = [[Rechteck() for _ in range(8)] for _ in range(8)]
        for zeile in range(8):
            for spalte in range(8):
                self.brett[zeile][spalte].GrößeSetzen(50, 50)
                self.brett[zeile][spalte].PositionSetzen(50 + spalte * 50, 400 - zeile * 50)
                self.brett[zeile][spalte].FarbeSetzen("schwarz" if (spalte + zeile) % 2 == 0 else "weiß")

    def SichtbarkeitSetzen(self, sichtbar):
        """
        Steuert die Sichtbarkeit des Schachbretts.
        """
        for zeile in range(8):
            for spalte in range(8):
                self.brett[zeile][spalte].SichtbarkeitSetzen(sichtbar)
  
class Damen:
    """
    Löst das Problem der 8 Damen.
    """
    def __init__(self):
        """
        Legt das Schachbrett an.
        """
        self.schachbrett = [[False for _ in range(8)] for _ in range(8)]
        self.SchrittAusführen(0)

    def IstFeldBedroht(self, zeile, spalte):
        """
        Testet, ob das angegebene Element des Schachbretts durch eine der bisher aufgestellten Damen bedroht ist.
        """
        aktspalte = spalte - 1
        while aktspalte >= 0:
            if self.schachbrett[zeile][aktspalte]:
                return True
            aktspalte -= 1

        aktspalte = spalte - 1
        aktzeile = zeile - 1
        while aktspalte >= 0 and aktzeile >= 0:
            if self.schachbrett[aktzeile][aktspalte]:
                return True
            aktspalte -= 1
            aktzeile -= 1

        aktspalte = spalte - 1
        aktzeile = zeile + 1
        while aktspalte >= 0 and aktzeile < len(self.schachbrett):
            if self.schachbrett[aktzeile][aktspalte]:
                return True
            aktspalte -= 1
            aktzeile += 1
        return False

    def LösungAusgeben(self):
        """
        Gibt die gefundene Lösung aus.
        """
        print("Lösung:")
        for spalte in range(len(self.schachbrett)):
            for zeile in range(len(self.schachbrett)):
                if self.schachbrett[zeile][spalte]:
                    print(f" {zeile}", end="")
            print()

    def SchrittAusführen(self, spalte):
        """
        Macht einen Rekursionsschritt auf dem Weg zur Lösung.
        """
        pass

d = Damen()
d.LösungAusgeben()
