import os

class Songwettbewerb:
    """
    Ermittelt günstige Paarungen von Coaches und Kandidaten für den Songwettbewerb
    """
    def __init__(self):
        self.kandidatenWunschlisteCoaches = []
        self.coachesWunschlisteKandidaten = []
        if not self.Lesen("Wunschlisten.txt"):
            return
        self.anzahl = len(self.coachesWunschlisteKandidaten)
        self.coachFürKandidat = [-1] * self.anzahl
        self.SchrittAusführen(0)

    def Lesen(self, name):
        """
        Liest die Wunschlistendaten aus der angegebenen Datei
        :param name: der Dateiname
        :return: wahr, wenn das Lesen erfolgreich war
        """
        try:
            with open(name, 'r') as eingabe:
                zeile = eingabe.readline()
                if zeile[0] != '*':
                    print("Falsche Dateistruktur Start")
                    return False
                zeile = eingabe.readline()
                pos = -1
                while zeile[0] != '*':
                    teile = zeile.strip().split(',')
                    pos += 1
                    self.kandidatenWunschlisteCoaches.append([int(num) for num in teile])
                    zeile = eingabe.readline()
                zeile = eingabe.readline()
                pos = -1
                while zeile[0] != '*':
                    teile = zeile.strip().split(',')
                    pos += 1
                    self.coachesWunschlisteKandidaten.append([int(num) for num in teile])
                    zeile = eingabe.readline()
            return len(self.kandidatenWunschlisteCoaches) == len(self.coachesWunschlisteKandidaten)
        except Exception as e:
            print(f"Fehler beim Lesen der Datei '{name}': {e}")
            return False

    def LösungAusgeben(self):
        """
        Gibt eine gefundene Lösung aus
        """
        for coach in self.coachFürKandidat:
            text = f"   {coach}"
            print(text[-3:], end='')
        print()  
        #Gemäß Teilaufgabe d ergänzen

    def CoachFürWunschwertGeben(self, kandidat, wunschwert):
        """
        Sucht für den angegebenen Kandidaten den Coach, den der Kandidat mit dem gegebenen Wunschwert haben möchte)
        :param kandidat: der Kandidat, für den der Coach gesucht wird
        :param wunschwert: der Wunschwert für den Coach
        """
        try:
            return self.kandidatenWunschlisteCoaches[kandidat].index(wunschwert)
        except ValueError:
            return -1

    def KandidatFürCoachGeben(self, coach):
        """
        Sucht denjenigen Kandidaten, dem der Coach zur Zeit zugeordnet ist.
        :param coach: Coach, dessen Kandidat gesucht wird
        """
        if coach in self.coachFürKandidat:
            return self.coachFürKandidat.index(coach)
        return -1

    def BleibtStabil(self, aktuellerKandidat, aktuellerCoach):
        """
        Testet, ob die Aufstellung nach Hinzufügen des Paares Kandidat/Coach stabil bleibt
        :param aktuellerKandidat: der Kandidat
        :param aktuellerCoach: und dessen geplanter Coach
        """
        for kandidat in range(aktuellerKandidat):
            if (self.kandidatenWunschlisteCoaches[kandidat][aktuellerCoach] > self.kandidatenWunschlisteCoaches[kandidat][self.coachFürKandidat[kandidat]] and
                self.coachesWunschlisteKandidaten[aktuellerCoach][kandidat] > self.coachesWunschlisteKandidaten[aktuellerCoach][aktuellerKandidat]):
                return False
        # gemäß Teilaufgabe c ergänzen
        return True

    def SchrittAusführen(self, kandidat):
        """
        Sucht einen Coach für den nächsten Kandidaten
        :param kandidat: der nächste Kandidat
        """
        # Gemäß Teilaufgabe b ergänzen

Songwettbewerb()